from typing import Any, Dict, Iterator, List, Mapping, Optional, Protocol, Tuple, Union

from django.http.request import HttpRequest
from django.template import TemplateDoesNotExist
from django.template.base import Context
from django.utils.safestring import SafeString

class BaseEngine:
    name: str = ...
    dirs: List[str] = ...
    app_dirs: bool = ...
    def __init__(self, params: Mapping[str, Any]) -> None: ...
    @property
    def app_dirname(self) -> Optional[str]: ...
    def from_string(self, template_code: str) -> _EngineTemplate: ...
    def get_template(self, template_name: str) -> _EngineTemplate: ...
    @property
    def template_dirs(self) -> Tuple[str]: ...
    def iter_template_filenames(self, template_name: str) -> Iterator[str]: ...

class _EngineTemplate(Protocol):
    def render(
        self,
        context: Optional[Union[Context, Dict[str, Any]]] = ...,
        request: Optional[HttpRequest] = ...,
    ) -> SafeString: ...
